<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 14/09/2015
 * Time: 14:59
 */

namespace Teknisa\CRM\Service;
use Doctrine\ORM\EntityManager;


class crm00004001IndicadorOperadorService {

    /** @var  EntityManager */
    protected $entityManager;
    /** @var  Environment */
    protected $environment;

    public function __construct($entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    public function getRowsByFilter(array $filterValues)
    {
        $where = "  AND";

        foreach($filterValues as $valuesToFilter)
        {
            if($valuesToFilter['operator'] == 'BETWEEN' && !(empty($valuesToFilter['value'][0]) && empty($valuesToFilter['value'][1])))
            {
                $where .= " TO_CHAR(".$valuesToFilter['columnName'].",'Mon/YYYY') ";

                if(!empty($valuesToFilter['value'][0]) && !empty($valuesToFilter['value'][1]))
                {
                    $dtini = explode('/',$valuesToFilter['value'][0]);
                    $dtfinal = explode('/',$valuesToFilter['value'][1]);
                    $where .= "BETWEEN '".$dtini[2]."/".$dtini[1]."' AND '".$dtfinal[2]."/".$dtfinal[1]."' AND ";
                }
                elseif(!empty($valuesToFilter['value'][0]) && empty($valuesToFilter['value'][1]))
                {
                    $dtini = explode('/',$valuesToFilter['value'][0]);
                    $where .= ">= '".$dtini[2]."/".$dtini[1]."' AND ";
                }
                elseif(empty($valuesToFilter['value'][0]) && !empty($valuesToFilter['value'][1]))
                {
                    $dtfinal = explode('/',$valuesToFilter['value'][1]);
                    $where .= "<= '".$dtfinal[2]."/".$dtfinal[1]."' AND ";
                }
            }
            else
            {
                if($valuesToFilter['operator'] == '=')
                {
                    if ($valuesToFilter['columnName'] == 'DTINCLUSAO')
                        $where .= " TO_CHAR(PROSP.".$valuesToFilter['columnName'].",'Mon/YYYY') = '".$valuesToFilter['value']."' AND ";
                    else
                        $where .= " PROSP.".$valuesToFilter['columnName']." = '".$valuesToFilter['value']."' AND ";
                }
                elseif($valuesToFilter['operator'] == 'IN')
                {
                    if($valuesToFilter['columnName']=='NRSEQCONTRATO')
                    {
                        $where .= " PROSP.".$valuesToFilter['columnName']." IN ('";
                    }
                    else
                    {
                        $where .= " ".$valuesToFilter['columnName']." IN ('";
                    }
                    foreach($valuesToFilter['value'] as $valor)
                    {
                        $where .= $valor."','";
                    }
                    $where = substr($where,0,strlen($where)-2).") AND ";
                }
            }
        }
        $where = substr($where,0,strlen($where)-5);

        $sql = "SELECT COUNT(NRCANDIDATO) AS QTDECAND,
                       PROSP.CDOPERINCLUSAO AS CDOPERINCLUSAO,
                       OPER.NMOPERADOR AS NMOPERADOR,
                       SUBSTR(OPER.NMOPERADOR,0,15) AS NMREDUZIDO
                  FROM CRM_CANDIDATO CAND
                 INNER JOIN PROSPECT PROSP
                    ON CAND.NRPARCNEGOCIO = PROSP.NRPARCNEGOCIO
                   AND CAND.NRORG = PROSP.NRORG
                 INNER JOIN OPERADOR OPER
                    ON PROSP.CDOPERINCLUSAO = OPER.CDOPERADOR
                   AND PROSP.NRORG = OPER.NRORG
                 WHERE PROSP.IDATIVO = 'S'
                   AND CAND.IDATIVO = 'S'
                         ";
        $sql .= $where;

        $sql .= "
                    GROUP BY PROSP.CDOPERINCLUSAO, OPER.NMOPERADOR, SUBSTR(OPER.NMOPERADOR,0,15)";

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();
        $dataSet = $std->fetchAll();

        return $dataSet;
    }
}